Bug 1465599 - Fix multiple issues with xt action
Fix multiple issues with xt action
Status: VERIFIED
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: iproute (Show other bugs)
7.4
Unspecified Unspecified
medium Severity medium
: rc
: ---
Assigned To: Phil Sutter
Jaroslav Aster
:
: 1513973 (view as bug list)
Depends On:
Blocks: 1470965
  Show dependency treegraph
 
Reported: 2017-06-27 13:42 EDT by Jaroslav Aster
Modified: 2017-12-13 12:19 EST (History)
5 users (show)

See Also:
Fixed In Version: iproute-4.11.0-5.el7
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: 1326726
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jaroslav Aster 2017-06-27 13:42:47 EDT
Bug for remaining issues from bug bz#1326726. Still not fully fixed. Tested on

iproute-3.10.0-87.el7

+++ This bug was initially created as a clone of Bug #1326726 +++

--- Additional comment from Phil Sutter on 2017-05-18 14:19:34 EDT ---

Hi Jaroslav,

(In reply to Jaroslav Aster from comment #6)
> Hi Phil,
> 
> unfortunately I see still a lot of fails and segfaults in my test case. Yes,
> there is some progress, but it is not definitely fixed. See
> 
> http://beaker-archive.app.eng.bos.redhat.com/beaker-logs/2017/04/18159/
> 1815921/3752192/54687568/TESTOUT.log

Yes, xt action is still buggy. The segfaults are all related to using any of the NAT targets (SNAT, DNAT, MASQUERADE and REDIRECT). I found the reason why it segfaults (which happens in libipt, BTW) and I have a workaround at hand. Problem is, these targets will still refuse to work then, just the segfault does not happen anymore.

Other non-functional targets are internal ones (ACCEPT, DROP, RETURN). This is also a known issue upstream.

You see, xt action has very limited use even upstream and so I don't see much sense in trying to get all these things functional.
Comment 1 Phil Sutter 2017-07-26 05:23:54 EDT
Upstream commit to backport (which prevents the segfault at least):

commit f6fc1055e41a8a924313c336b39b9ffe0c86938b
Author: Phil Sutter <psutter@redhat.com>
Date:   Tue May 23 15:40:57 2017 +0200

    tc: m_xt: Prevent a segfault in libipt
    
    This happens with NAT targets, such as SNAT, DNAT and MASQUERADE. These
    are still not usable with this patch, but at least tc doesn't crash
    anymore when one tries to use them.
    
    Signed-off-by: Phil Sutter <phil@nwl.cc>
Comment 3 Jaroslav Aster 2017-11-08 08:32:36 EST
Hi Phil,

I can confirm that there are no segfaults anymore, but there are still a lot of issues to solve.

I'm not sure what we should do with this bug.
Comment 4 Phil Sutter 2017-11-08 10:15:45 EST
Hi Jaroslav,

(In reply to Jaroslav Aster from comment #3)
> Hi Phil,
> 
> I can confirm that there are no segfaults anymore, but there are still a lot
> of issues to solve.
> 
> I'm not sure what we should do with this bug.

There are conceptual problems with xt action, I don't think it is even possible to address all of them. Assuming that anyone using it should be aware of its limitations, I'd say making sure tc doesn't crash is about the best we can do.
Comment 6 Phil Sutter 2017-12-13 12:19:19 EST
*** Bug 1513973 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.